#!/bin/csh

rm output_cross.out *.xy *.xyz *.res 
rm bin/fort.111

#------------------------------------------------
#-- Check for number of arguments
if ( $#argv == 5 ) then
  set clat = $1	
  set clon = $2
  set az = $3
  set vmax = $4
  set step = $5
  echo ""
  echo "USING PLOTING TOOL BOX"
  echo "with CLAT CLON AZ"
  echo "egal " ${clat} ${clon} ${az} "degrees"
else 
  set clat = 0
  set clon = 40
  set az = 30
  set vmax = 2
  set step = 0.2
  echo ""
  echo "USING PLOTING TOOL BOX"
  echo "WARMNING : using the default values"
  echo "with CLAT CLON AZ "
  echo "egal " ${clat}  ${clon}  ${az} "degrees"
endif
#------------------------------------------------

cd bin
echo ""
echo "RUNNING FORTRAN CODE" 
echo ""
./cross_180.exe  << !
$clat $clon $az
!

cd ..
echo "MAKING GMT PLOT" 
echo ""
./coupes.gmt $clat $clon $az $vmax $step
