!=====================================================================
!                          PROFILE-MAKER PROGRAM
!       S. Durand, May 2016, V0.0 
!=====================================================================
       implicit none
!    Nombres de degres inverse pour chaque donnees
       integer c,NSmax,np,model,NN,spline,k,l,ddeg,kk,ddepth,lay
       parameter (np=9240,NSmax=20,model=578,NN=21,spline=1)
!   earth model
       real(kind=8) r(model),rho(model),kappa(model),mu(model),
     +        rhos2(model),qkap(model),qmu(model),pg(model)
       real(kind=8) radial_basis(model,0:NN-1)
       real(kind=8) p(np),xx,yy,dp(np)
       real(kind=8) depth,rad(model)
       integer nrp,igrc
!   Nom fichiers
       character*(80) filename2
       character str1*12,str2*12
!   Normalization
       real(kind=8) pig,a,g,pi,rhobar,wnorm,vnorm,wes
       real(kind=8) dg2rad 

       common pig,a,g,pi,rhobar,wnorm,vnorm,wes
       common dg2rad

ccccccccc1ccccccccc2ccccccccc3ccccccccc4ccccccccc5ccccccccc6ccccccccc7cc

!       Normalisation as minos: 
       pig=1.d0
       a=6371000.d0                    ! mean earth radius (m)
       g=6.6723d-11                    ! Newtonian gravity constant
       pi=dacos(-1.d0)
       rhobar=5515.d0                  ! mean earth density
       wnorm=dsqrt(pi*g*rhobar)       ! frequency normalization =environ 1.07 mHz
       vnorm=a*wnorm                   ! velocity normalization
       wes=1.d3*wnorm/(2.d0*pi)        ! frequence en mHz
       dg2rad=pi/360.d0


!   read center lat, center lon and az
        read(*,*) ddepth
        depth=dfloat(ddepth)

!----------------------------------------------------------------------
!        read spline functions 
!        read model coefficients
!----------------------------------------------------------------------

       open(3,file='../data/spline_basis.dat')
       do l=0,NN-1
       do k=1,model
       read(3,*) rad(k),yy,radial_basis(k,l)
       enddo
       enddo
       close(3)

       write(111,*) 'Spline base computed' 

       open(1,file='../models/SEISGLOB1.sph')
       do k=1,np 
       read(1,*) p(k),dp(k)       
       enddo
       close(1)

       write(111,*) 'Model coefficients read' 


!----------------------------------------------------------------------
!        Make map .xyz file 
!----------------------------------------------------------------------

       call sph2geo2(NSmax,p,np,radial_basis,
     +       '../map_NEW_SEISGLOB1.xyz',NN,model,depth,rad)

       end 



